<?php
/**
 * InlineResponse20110Content
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20110Content Class Doc Comment
 *
 * @category Class
 * @description Describes a day closing of a timestamp statistic. Here, all values are persisted into the database with infos about working time, vacation, documented supports and the balance for this day.
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20110Content implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_201_10_content';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'employeeId' => 'int',
        'date' => '\DateTime',
        'totalTimestampWorkTime' => 'int',
        'paidAbsences' => 'int',
        'unpaidAbsences' => 'int',
        'documentedSupport' => 'int',
        'workingTime' => 'int',
        'workingTimeCleaned' => 'int',
        'totalTime' => 'int',
        'documentedPercentage' => 'int',
        'balance' => 'int',
        'completedByEmployeeId' => 'int',
        'completedOnDate' => 'int',
        'totalBalance' => 'int',
        'totalBalanceBeforeTimeframe' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'employeeId' => null,
        'date' => 'date',
        'totalTimestampWorkTime' => null,
        'paidAbsences' => null,
        'unpaidAbsences' => null,
        'documentedSupport' => null,
        'workingTime' => null,
        'workingTimeCleaned' => null,
        'totalTime' => null,
        'documentedPercentage' => null,
        'balance' => null,
        'completedByEmployeeId' => null,
        'completedOnDate' => 'timestamp',
        'totalBalance' => null,
        'totalBalanceBeforeTimeframe' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'employeeId' => 'employeeId',
        'date' => 'date',
        'totalTimestampWorkTime' => 'totalTimestampWorkTime',
        'paidAbsences' => 'paidAbsences',
        'unpaidAbsences' => 'unpaidAbsences',
        'documentedSupport' => 'documentedSupport',
        'workingTime' => 'workingTime',
        'workingTimeCleaned' => 'workingTimeCleaned',
        'totalTime' => 'totalTime',
        'documentedPercentage' => 'documentedPercentage',
        'balance' => 'balance',
        'completedByEmployeeId' => 'completedByEmployeeId',
        'completedOnDate' => 'completedOnDate',
        'totalBalance' => 'totalBalance',
        'totalBalanceBeforeTimeframe' => 'totalBalanceBeforeTimeframe'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'employeeId' => 'setEmployeeId',
        'date' => 'setDate',
        'totalTimestampWorkTime' => 'setTotalTimestampWorkTime',
        'paidAbsences' => 'setPaidAbsences',
        'unpaidAbsences' => 'setUnpaidAbsences',
        'documentedSupport' => 'setDocumentedSupport',
        'workingTime' => 'setWorkingTime',
        'workingTimeCleaned' => 'setWorkingTimeCleaned',
        'totalTime' => 'setTotalTime',
        'documentedPercentage' => 'setDocumentedPercentage',
        'balance' => 'setBalance',
        'completedByEmployeeId' => 'setCompletedByEmployeeId',
        'completedOnDate' => 'setCompletedOnDate',
        'totalBalance' => 'setTotalBalance',
        'totalBalanceBeforeTimeframe' => 'setTotalBalanceBeforeTimeframe'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'employeeId' => 'getEmployeeId',
        'date' => 'getDate',
        'totalTimestampWorkTime' => 'getTotalTimestampWorkTime',
        'paidAbsences' => 'getPaidAbsences',
        'unpaidAbsences' => 'getUnpaidAbsences',
        'documentedSupport' => 'getDocumentedSupport',
        'workingTime' => 'getWorkingTime',
        'workingTimeCleaned' => 'getWorkingTimeCleaned',
        'totalTime' => 'getTotalTime',
        'documentedPercentage' => 'getDocumentedPercentage',
        'balance' => 'getBalance',
        'completedByEmployeeId' => 'getCompletedByEmployeeId',
        'completedOnDate' => 'getCompletedOnDate',
        'totalBalance' => 'getTotalBalance',
        'totalBalanceBeforeTimeframe' => 'getTotalBalanceBeforeTimeframe'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['totalTimestampWorkTime'] = $data['totalTimestampWorkTime'] ?? null;
        $this->container['paidAbsences'] = $data['paidAbsences'] ?? null;
        $this->container['unpaidAbsences'] = $data['unpaidAbsences'] ?? null;
        $this->container['documentedSupport'] = $data['documentedSupport'] ?? null;
        $this->container['workingTime'] = $data['workingTime'] ?? null;
        $this->container['workingTimeCleaned'] = $data['workingTimeCleaned'] ?? null;
        $this->container['totalTime'] = $data['totalTime'] ?? null;
        $this->container['documentedPercentage'] = $data['documentedPercentage'] ?? null;
        $this->container['balance'] = $data['balance'] ?? null;
        $this->container['completedByEmployeeId'] = $data['completedByEmployeeId'] ?? null;
        $this->container['completedOnDate'] = $data['completedOnDate'] ?? null;
        $this->container['totalBalance'] = $data['totalBalance'] ?? null;
        $this->container['totalBalanceBeforeTimeframe'] = $data['totalBalanceBeforeTimeframe'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the employee for this day closing
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return \DateTime|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param \DateTime|null $date day for this day closing (YYYY-mm-dd)
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets totalTimestampWorkTime
     *
     * @return int|null
     */
    public function getTotalTimestampWorkTime()
    {
        return $this->container['totalTimestampWorkTime'];
    }

    /**
     * Sets totalTimestampWorkTime
     *
     * @param int|null $totalTimestampWorkTime Number of total minutes of all WORK timstamp periods for this day
     *
     * @return self
     */
    public function setTotalTimestampWorkTime($totalTimestampWorkTime)
    {
        $this->container['totalTimestampWorkTime'] = $totalTimestampWorkTime;

        return $this;
    }

    /**
     * Gets paidAbsences
     *
     * @return int|null
     */
    public function getPaidAbsences()
    {
        return $this->container['paidAbsences'];
    }

    /**
     * Sets paidAbsences
     *
     * @param int|null $paidAbsences Number of total minutes of paid absences (= vacation, illness, overtime and paid absences)
     *
     * @return self
     */
    public function setPaidAbsences($paidAbsences)
    {
        $this->container['paidAbsences'] = $paidAbsences;

        return $this;
    }

    /**
     * Gets unpaidAbsences
     *
     * @return int|null
     */
    public function getUnpaidAbsences()
    {
        return $this->container['unpaidAbsences'];
    }

    /**
     * Sets unpaidAbsences
     *
     * @param int|null $unpaidAbsences Number of total minutes of unpaid absences (= unpaid absences)
     *
     * @return self
     */
    public function setUnpaidAbsences($unpaidAbsences)
    {
        $this->container['unpaidAbsences'] = $unpaidAbsences;

        return $this;
    }

    /**
     * Gets documentedSupport
     *
     * @return int|null
     */
    public function getDocumentedSupport()
    {
        return $this->container['documentedSupport'];
    }

    /**
     * Sets documentedSupport
     *
     * @param int|null $documentedSupport Number of total minutes of all documented supportd
     *
     * @return self
     */
    public function setDocumentedSupport($documentedSupport)
    {
        $this->container['documentedSupport'] = $documentedSupport;

        return $this;
    }

    /**
     * Gets workingTime
     *
     * @return int|null
     */
    public function getWorkingTime()
    {
        return $this->container['workingTime'];
    }

    /**
     * Sets workingTime
     *
     * @param int|null $workingTime The number of minutes, the employee has to work on this day (based on his working time model)
     *
     * @return self
     */
    public function setWorkingTime($workingTime)
    {
        $this->container['workingTime'] = $workingTime;

        return $this;
    }

    /**
     * Gets workingTimeCleaned
     *
     * @return int|null
     */
    public function getWorkingTimeCleaned()
    {
        return $this->container['workingTimeCleaned'];
    }

    /**
     * Sets workingTimeCleaned
     *
     * @param int|null $workingTimeCleaned Subtracts the \"workingTime\" with the minutes of \"paid absences\", thus returning the \"effective\" working time the employee has to work
     *
     * @return self
     */
    public function setWorkingTimeCleaned($workingTimeCleaned)
    {
        $this->container['workingTimeCleaned'] = $workingTimeCleaned;

        return $this;
    }

    /**
     * Gets totalTime
     *
     * @return int|null
     */
    public function getTotalTime()
    {
        return $this->container['totalTime'];
    }

    /**
     * Sets totalTime
     *
     * @param int|null $totalTime Cumulating the \"totalTimestampWorkTime\", \"paidAbsences\" and \"unpaidAbsences\"
     *
     * @return self
     */
    public function setTotalTime($totalTime)
    {
        $this->container['totalTime'] = $totalTime;

        return $this;
    }

    /**
     * Gets documentedPercentage
     *
     * @return int|null
     */
    public function getDocumentedPercentage()
    {
        return $this->container['documentedPercentage'];
    }

    /**
     * Sets documentedPercentage
     *
     * @param int|null $documentedPercentage a ration between the documented supports to the \"WORK\" timestamps
     *
     * @return self
     */
    public function setDocumentedPercentage($documentedPercentage)
    {
        $this->container['documentedPercentage'] = $documentedPercentage;

        return $this;
    }

    /**
     * Gets balance
     *
     * @return int|null
     */
    public function getBalance()
    {
        return $this->container['balance'];
    }

    /**
     * Sets balance
     *
     * @param int|null $balance returns the effective balance for this account (= totalTime - workingTimeCleaned)
     *
     * @return self
     */
    public function setBalance($balance)
    {
        $this->container['balance'] = $balance;

        return $this;
    }

    /**
     * Gets completedByEmployeeId
     *
     * @return int|null
     */
    public function getCompletedByEmployeeId()
    {
        return $this->container['completedByEmployeeId'];
    }

    /**
     * Sets completedByEmployeeId
     *
     * @param int|null $completedByEmployeeId the id of the employee who has approved the day
     *
     * @return self
     */
    public function setCompletedByEmployeeId($completedByEmployeeId)
    {
        $this->container['completedByEmployeeId'] = $completedByEmployeeId;

        return $this;
    }

    /**
     * Gets completedOnDate
     *
     * @return int|null
     */
    public function getCompletedOnDate()
    {
        return $this->container['completedOnDate'];
    }

    /**
     * Sets completedOnDate
     *
     * @param int|null $completedOnDate the timestamp, when the employee has approved the day closing
     *
     * @return self
     */
    public function setCompletedOnDate($completedOnDate)
    {
        $this->container['completedOnDate'] = $completedOnDate;

        return $this;
    }

    /**
     * Gets totalBalance
     *
     * @return int|null
     */
    public function getTotalBalance()
    {
        return $this->container['totalBalance'];
    }

    /**
     * Sets totalBalance
     *
     * @param int|null $totalBalance the total balance of all previous days accumulated, plus the balance of the current day
     *
     * @return self
     */
    public function setTotalBalance($totalBalance)
    {
        $this->container['totalBalance'] = $totalBalance;

        return $this;
    }

    /**
     * Gets totalBalanceBeforeTimeframe
     *
     * @return int|null
     */
    public function getTotalBalanceBeforeTimeframe()
    {
        return $this->container['totalBalanceBeforeTimeframe'];
    }

    /**
     * Sets totalBalanceBeforeTimeframe
     *
     * @param int|null $totalBalanceBeforeTimeframe the total balance of all previous -not shown- days accumulated
     *
     * @return self
     */
    public function setTotalBalanceBeforeTimeframe($totalBalanceBeforeTimeframe)
    {
        $this->container['totalBalanceBeforeTimeframe'] = $totalBalanceBeforeTimeframe;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


